;*********1_BASLAT_1_DUR_TUSUYLA_2_MOTORUN_KOSULLU_DENETIMI**********
	
		LIST	    P=18F2550
		#include    "p18F2550.inc"
		
;********************DUZENLEME_BITLERI***********************
		
; CONFIG1L
  CONFIG  PLLDIV = 1            ; PLL Prescaler Selection bits (No prescale (4 MHz oscillator input drives PLL directly))
  CONFIG  CPUDIV = OSC1_PLL2    ; System Clock Postscaler Selection bits ([Primary Oscillator Src: /1][96 MHz PLL Src: /2])
  CONFIG  USBDIV = 1            ; USB Clock Selection bit (used in Full-Speed USB mode only; UCFG:FSEN = 1) (USB clock source comes directly from the primary oscillator block with no postscale)

; CONFIG1H
  CONFIG  FOSC = INTOSC_XT      ; Oscillator Selection bits (Internal oscillator, XT used by USB (INTXT))
  CONFIG  FCMEN = OFF           ; Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
  CONFIG  IESO = OFF            ; Internal/External Oscillator Switchover bit (Oscillator Switchover mode disabled)

; CONFIG2L
  CONFIG  PWRT = ON             ; Power-up Timer Enable bit (PWRT enabled)
  CONFIG  BOR = ON              ; Brown-out Reset Enable bits (Brown-out Reset enabled in hardware only (SBOREN is disabled))
  CONFIG  BORV = 3              ; Brown-out Reset Voltage bits (Minimum setting 2.05V)
  CONFIG  VREGEN = OFF          ; USB Voltage Regulator Enable bit (USB voltage regulator disabled)

; CONFIG2H
  CONFIG  WDT = OFF             ; Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
  CONFIG  WDTPS = 32768         ; Watchdog Timer Postscale Select bits (1:32768)

; CONFIG3H
  CONFIG  CCP2MX = ON           ; CCP2 MUX bit (CCP2 input/output is multiplexed with RC1)
  CONFIG  PBADEN = OFF          ; PORTB A/D Enable bit (PORTB<4:0> uclari sifirlama(reset) sonrasında dijital giris-cikis olacak sekilde duzenlendi)
  CONFIG  LPT1OSC = OFF         ; Low-Power Timer 1 Oscillator Enable bit (Timer1 configured for higher power operation)
  CONFIG  MCLRE = ON            ; MCLR Pin Enable bit (MCLR pin enabled; RE3 input pin disabled)

; CONFIG4L
  CONFIG  STVREN = ON           ; Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
  CONFIG  LVP = OFF              ; Single-Supply ICSP Enable bit (Single-Supply ICSP disabled)
  CONFIG  XINST = OFF           ; Extended Instruction Set Enable bit (Instruction set extension and Indexed Addressing mode disabled (Legacy mode))

; CONFIG5L
  CONFIG  CP0 = OFF             ; Code Protection bit (Block 0 (000800-001FFFh) is not code-protected)
  CONFIG  CP1 = OFF             ; Code Protection bit (Block 1 (002000-003FFFh) is not code-protected)
  CONFIG  CP2 = OFF             ; Code Protection bit (Block 2 (004000-005FFFh) is not code-protected)
  CONFIG  CP3 = OFF             ; Code Protection bit (Block 3 (006000-007FFFh) is not code-protected)

; CONFIG5H
  CONFIG  CPB = OFF             ; Boot Block Code Protection bit (Boot block (000000-0007FFh) is not code-protected)
  CONFIG  CPD = OFF             ; Data EEPROM Code Protection bit (Data EEPROM is not code-protected)

; CONFIG6L
  CONFIG  WRT0 = OFF            ; Write Protection bit (Block 0 (000800-001FFFh) is not write-protected)
  CONFIG  WRT1 = OFF            ; Write Protection bit (Block 1 (002000-003FFFh) is not write-protected)
  CONFIG  WRT2 = OFF            ; Write Protection bit (Block 2 (004000-005FFFh) is not write-protected)
  CONFIG  WRT3 = OFF            ; Write Protection bit (Block 3 (006000-007FFFh) is not write-protected)

; CONFIG6H
  CONFIG  WRTC = OFF            ; Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) are not write-protected)
  CONFIG  WRTB = OFF            ; Boot Block Write Protection bit (Boot block (000000-0007FFh) is not write-protected)
  CONFIG  WRTD = OFF            ; Data EEPROM Write Protection bit (Data EEPROM is not write-protected)

; CONFIG7L
  CONFIG  EBTR0 = OFF           ; Table Read Protection bit (Block 0 (000800-001FFFh) is not protected from table reads executed in other blocks)
  CONFIG  EBTR1 = OFF           ; Table Read Protection bit (Block 1 (002000-003FFFh) is not protected from table reads executed in other blocks)
  CONFIG  EBTR2 = OFF           ; Table Read Protection bit (Block 2 (004000-005FFFh) is not protected from table reads executed in other blocks)
  CONFIG  EBTR3 = OFF           ; Table Read Protection bit (Block 3 (006000-007FFFh) is not protected from table reads executed in other blocks)

; CONFIG7H
  CONFIG  EBTRB = OFF           ; Boot Block Table Read Protection bit (Boot block (000000-0007FFh) is not protected from table reads executed in other blocks)
		

  
;**********-------TANIMLAMA_VE_ATAMALAR--------**************
     		
WREG_GC	    EQU	0X00	    ;Kesmelerde eger gerekirse WREG ve STATUS yazmaclarinin yedeklenmesi
STAT_GC	    EQU	0X01	    ;icin dosyalar.
SUREV_BYRK  EQU	0X02	    ;Surelerin doldugunu gosteren bayraklari tutan dosya.
ON	EQU 1		;10 saniye bayrak biti.
OTUZ	EQU 2		;30 saniye bayrak biti.
DON0	    EQU	0X03	    ;ARK gecikmesi icin tutma dosyasi.
DON1	    EQU	0X04	    ;ARK gecikmesi icin tutma dosyasi.
SAY10	    EQU	0X05	    ;10 saniye icin yazilim sayaci dosyasi.
SAY30	    EQU	0X06	    ;30 saniye icin yazilim sayaci dosyasi.
AAR_SR_SIFIRLA	EQU 0X07    ;Motorlarin gereken calisma surelerini doldurmadan hata vermeleri durumunda 
AAR1_SR	EQU 1		    ;kurulcak bayraklari tutacak dosya.
AAR2_SR	EQU 2
	    
;Her bir Portun giris cikis islevine ozel, program icinde kullanmak ve  
;giris-cikislari daha kolay anımsayabilmek icin bir ad veriliyor.
	
#DEFINE	    M1HONAY PORTA,1	;Motor-1 Hata (Duzeltildi) butonu girisi.
#DEFINE	    M2HONAY PORTA,2	;Motor-2 Hata (Duzeltildi) butonu girisi.
#DEFINE	    DEI	    PORTA,3	;Sayac gosterge etkinlestirme (Display Enable In) denetim cikisi.
#DEFINE	    INH	    PORTA,5	;Sayac saat darbelerini engelleme (Clock Inhibit) denetim cikisi.
#DEFINE	    AAR1KES PORTB,1	;Yuksek oncelikli Asiri Akim Rolesi-1 harici kesme giris ucu.
#DEFINE	    AAR2KES PORTB,2	;Yuksek oncelikli Asiri Akim Rolesi-2 harici kesme giris ucu.
#DEFINE	    B	    PORTB,3	;Baslatma butonu giris ucu.
#DEFINE	    DUR	    PORTB,4	;Durdurma butonu giris ucu.
#DEFINE	    RST	    PORTC,0	;Sayac sifirlama(reset) denetim cikisi.
#DEFINE	    M1HATA  PORTC,1	;Motor-1 Hata gosterge cikisi (LED).
#DEFINE	    M2HATA  PORTC,2	;Motor-2 Hata gosterge cikisi (LED).
#DEFINE	    M1	    PORTC,6	;Motor-1 surme cikis ucu.
#DEFINE	    M2	    PORTC,7	;Motor-2 surme cikis ucu.
	    
	    
	    
;------------------------------------------------------------

	    ORG    0x0000	;Baslangic adresine yonel
	    BRA    GIRIS
	    
	    ORG    0x0008	;Yuksek oncelikli Hata kesme program adresine yonel
	    BRA    DENET 
	    
	    ORG    0x0018	;Dusuk oncelikli Timer0 kesme program adresine yonel
	    BRA    SUREV
	    
;-------------------------------------------------------------

;*********************ANA_PROGRAM*****************************
	    
GIRIS
	    CLRF	PORTC	    ;Tum PORTlari temizle/sifirla
	    CLRF	PORTB	    ;	
	    CLRF	PORTA	    ;
	    CLRF	SUREV_BYRK  ;Sure durum bayraklarini tutan dosyayi temizle.
	    CLRF	AAR_SR_SIFIRLA	;Motorlarda hata oldugunda sure sifirlama bayraklarini tutan dosyayi temizle. 
	    CLRF	INTCON	    ;Baslangicta veya herhangi bir RESET durumunda
	    CLRF	INTCON2	    ;istenmeyen kesmelerin olusmamasi icin
	    CLRF	INTCON3	    ;INTCONx ve T0CON yazmaclarini temizle.
	    CLRF	T0CON	    ;Timer0 Denetim yazmacini ve ayarlarini temizle.
	    CLRF	UCON		;RC4 ve RC5 bacaklarini I/O olarak sorunsuz
	    BSF		UCFG, UTRDIS	;kullanabilmek icin gerekli islem (istege bagli).
	    CLRF	PIE1	    ;RESET sonrası hatali kesmelere gitmemesi icin
	    CLRF	PIE2	    ;yapilması gerekli işlem.
	    MOVLW	0X0E
	    MOVWF	ADCON1	    ;Analog girisler etkisiz; PORTA-B dijital giris-cikis.
	    MOVLW	0X80
	    MOVWF       RCON	    ;Kesme onceligi etkin IPEN=1 (Interrupt Priority Enable).
	    MOVLW	0X4F	    ;Sistem Saati Kaynagi: Dahili 8MHz Osilator (SCS<1:0> = 11)	
	    MOVWF	OSCCON	    ;Dahili osilator hizi=1MHz (IRCF<2:0> = 100)
	    ;Ben fazla osilator hizi gerekmedigi icin 1MHz olarak belirledim. Bu hiz duzenegin tutarli 
	    ;islemesi icin oldukca yeterlidir. Buna gore CPU saati Fosc/4 oldugundan; 250KHz olacaktir.
	    ;Yani bir komutu isleme(execute) suresi T=1/F, T=1/250000, T = 4us (mikrosaniye) olur.
	    ;Ayrintili osilator ayarlari icin urunun veribetinin(datasheet) 52. sayfasina bakiniz.
	    MOVLW	0X00
	    MOVWF	TRISC	    ;C portu tumden cikis.
	    MOVLW	0XFF
	    MOVWF	TRISB	    ;B portu tumden giris.
	    MOVLW	0XD7	
	    MOVWF	TRISA	    ;PORTA 5 ve 3 = cikis, 2 ve 1 = giris
	    BCF		DEI	    ;Gostergeyi etkisizlestir.
	    BCF		INH	    ;Saat darbelerini askiya al.
	    BSF		RST	    ;Sayaci RESET/Sifirlama durumunda tut.
;	    
	    MOVLW	0XE0	    ;Kuresel Kesmeler(GIEL), Cevresel Kesmeler(PEIE)
	    MOVWF	INTCON	    ;ve Timer0 Kesmesi(TMR0IE) etkin
;	    
	    MOVLW	0XC0	    ;PortB Pull-up direncleri etkisiz, AAR kesmeleri (INTEDG1, INTEDG2) 
	    MOVWF	INTCON2	    ;dusen kenar tetikemeli, Timer0 kesme onceligi(TMR0IP): dusuk.
;	    
	    MOVLW	0XC8	    ;AAR kesmeleri onceligi(INT2IP, INT1IP): yuksek. AAR1 kesmesi (INT1IE)etkin.
	    MOVWF	INTCON3	    
;	    
	    MOVLW	0X57	    ;PIC18F2550'de Timer0 ya 8-bit ya da 16-bitlik sayici/zamanlayici olarak kullanılabilir.
	    MOVWF	T0CON	    ;Burada 8-bitlik kipte(modda) kullanilmistir(T08BIT=1). Timer0 saat kaynagi(T0SE): Dahili saat kaynagi
				    ;Ayrica bu aygitta Onolcekci(Prescaler) yalnizca Timer0 icin kullanilmaktadir.
				    ;Onolcekci(prescaler) oranı: 1/256 (T0PS<2:0> = 111)
				    
	    MOVLW	.38	    
	    MOVWF	SAY10	    ;10 saniye icin yazilim sayaci dosyasi; desimal 38 ile onyukle.
	    MOVLW	.115
	    MOVWF	SAY30	    ;30 saniye icin yazilim sayaci dosyasi; desimal 115 ile onyukle.
	    
;		ANA PROGRAM BASLANGICI
	    
BASLAT		;0X00
	    BTFSS   B		;Baslat butonu basılı mı?
	    GOTO    BASLAT	;Hayir, oyleyse bailana dek denetlemeyi surdur (BASLAT'a git)
	    CALL    ARK		;Evet, oyleyse buton arkini onlemek icin yaklasik 50ms bekle
	    BSF	    M1		;Motor-1'i calistir.
	    NOP			;Islem yok
	    BSF	    DEI		;Sayac gostergesini etkinlestir.
	    NOP			;Islem yok.
	    BCF	    RST		;Sayaci(CD4026x2) etkinlestir.
	    NOP			;Islem yok.
	    BSF	    T0CON, TMR0ON	;Timer0'i etkinlestir.
	    
BASLAT2
	    BTFSS   SUREV_BYRK, ON	    ;10 saniyenin dolmasini bekle
	    GOTO    BASLAT2		    ;10 saniye dolana kadar dongude kal.
	    BCF	    DEI			    ;Gostergeyi kapat.
	    NOP
	    BSF	    RST			    ;Sayicilari sifirla
	    CLRF    AAR_SR_SIFIRLA	    ;AAR kesmesinin AAR sure sifirlama bayraklarını temizle
	    BSF	    INTCON3, INT2IE	    ;M2 calismadan once AAR2 (koruma/hata) kesmesini etkinlestir
	    BSF	    M2			    ;M2 yi calistir.
	    CALL    ARK			    ;50ms gecik.
	    BSF	    DEI			    ;Gostergeyi yeniden ac.	
	    NOP
	    BCF	    RST			    ;Sayicilari sifirlama durumundan cikar.
	    
M2_BEKLE
	    BTFSS   SUREV_BYRK, OTUZ	    ;30 saniyenin dolmasini bekle
	    GOTO    M2_BEKLE		    ;30 saniye dolana dek dongude kal.
	    BCF	    DEI			    ;Gstergeleri kapat
	    CALL    ARK			    ;Gecikme
	    BSF	    RST			    ;Sayma islemleri bitti, Sayicilari sifirla
	    NOP
DURM2	    BTFSC   DUR			;Durdurma butonu basili mi?
	    GOTO    DURM2		;Hayir, oyleyse basilana kadar durumu koru ve dongude kal.
	    CALL    ARK			;Evet, buton arkini onlemek ici gecikme alt progamini cagir.
	    BCF	    INTCON3, INT2IE	;AAR2 kesmesini etkisizlestir.
	    BTFSC   INTCON3, INT2IE	;AAR2 kesmesinin etkisiz oldugundan emin ol
	    BRA	    $-2			;Hala etkisiz degilse etkisizlestirmek icin 2 adim geriye git.
	    BCF	    M2		    ;Etkisizlestirildiyse once Motor2'yi durdur.
	    CALL    ARK	    
	    CALL    ARK		    
	    CALL    ARK		    ;Yaklasik 150ms bekle
DURTUM	    
	    BTFSC   DUR		;Durdurma butonu yeniden basili mi?
	    GOTO    DURTUM	;Hayir, oyleyse basilana kadar dongude kal.
	    CALL    ARK		;Evet, ark gecikmesi.
	    RESET	    ;Tum duzenegi sifirla(resetle).
	    
;		YAKLASIK 50ms'LIK GECIKME ALT PROGRAMI
	    
ARK	
	MOVLW	.65
	MOVWF	DON0
ARK1	MOVLW	.255
	MOVWF	DON1
ARK2	DECFSZ	DON1, 1
	GOTO	ARK2
	DECFSZ	DON0, 1
	GOTO	ARK1
      	RETURN
	
;**********************ASIRI_AKIM/YUK/HATA_KESME_SERVIS_RUTINI****************************
	
DENET		;Kesme kayanagini belirle
	    CLRF    INTCON		;Kesmeleri etkisizlestir
	    BCF	    T0CON, TMR0ON	;Timer0 i kapat
	    BCF	    DEI			;Gostergeyi kapat
	    NOP				
	    BSF	    INH			;Sayicinin saat darbelerini engelle.
	    BTFSC   INTCON3, INT1IF	;AAR1 kesmesi mi?
	    GOTO    AAR1		;Evet, AAR1 kesme servisine git
	    BTFSC   INTCON3, INT2IF	;Hayir, AAR2 kesmesi mi?
	    GOTO    AAR2		;Evet, AAR2 kesme servisine git
	    BRA	    AAR_SON		;Hayir, ikisinden hiç biri dgilse kesmeyi sonlama servisine git
	
;	    ASIRI AKIM/YUK/HATA-1 KESME ALT PROGRAMI
	    
AAR1
	    BCF	    M1			;M1 i durdur
AAR1_1
	    BTG	    M1HATA		;M1 icin hata gostergesinden sinyal ver
	    CALL    ARK		    ;Gecikme
	    BTFSS   M1HONAY		;Hata duzeltme onaylandi mi?
	    GOTO    AAR1_1		;Hayir, hata sinyali vermeyi surdur (AAR1_1'e geri don)
	    BTFSS   AAR1KES		;Evet, hata duzeltildi mi?
	    GOTO    AAR1_1		;Hayir, hata sinyali vermeyi surdur (AAR1_1'e geri don)
	    BTFSS   SUREV_BYRK, ON	    ;Evet, 1. Motor 10s calisti mi?
	    CALL    AAR1_SR_SIFIRLA	    ;Hayir, oyleyse yeniden 10 sn saymak icin alt programi cagir.
	    BTFSS   AAR_SR_SIFIRLA, AAR1_SR	    ;Evet, 1. Motor 10s calismadan durdu mu?
	    CALL    M2BEKLE_KUR		    ;Hayir, o zaman yeniden 30sn calismasi icin alt prgrmi cagir.
	    BTFSS   AAR_SR_SIFIRLA, AAR1_SR	;Evetse, 1. motor yeniden kurudu mu?
	    BSF	    M1			    ;Evetse, bu komutu atla cunku zaten 1. motor BASLAT2_KUR alt programında devreye alınacak.
					    ;Hayirsa, bu komutu isle ve 1. Motoru calistir.
	    BCF	    M1HATA		    ;M1 Hata gostergesini kapat 
	    BRA	    AAR_SON		    ;Kesme sonlama servisine git
	    
	    ;	    ASIRI AKIM/YUK/HATA-2 KESME ALT PROGRAMI
AAR2
	    BCF	    M2	    ;Motor-2 yi durdur.
AAR2_1
	    BTG	    M2HATA	;M2 icin hata sinyali ver
	    CALL    ARK	    ;Gecikme
	    BTFSS   M2HONAY	;Hata duzeltme onaylandi mi?
	    GOTO    AAR2_1	;Hayirsa, hata sinyali dongusunde kal.
	    BTFSS   AAR2KES	;Evetse, Hata duzeltildi mi?
	    GOTO    AAR2_1	;Hayirsa, hata sinyali dongusunde kal.
	    BTFSS   SUREV_BYRK, OTUZ	    ;Evetse, 2. motor 30s calisti mi?
	    CALL    AAR2_SR_SIFIRLA	    ;Hayirsa, 2. motoru yeniden 30s calistirma alt prg cagir.
	    BTFSS   AAR_SR_SIFIRLA, AAR2_SR	;Evetse, 2. motor yeniden calistirilmis mi?
	    BSF	    M2			    ;Hayirsa 2. motoru calistir. Evetse burayı atla.
	    BCF	    M2HATA		;Evetse, Hata sinyali vermeyi durdur.
	    
;	    ASIRI AKIM/YUK/HATA KESME SERVIS RUTINI SONLAMA ALT PROGRAMI
	    
AAR_SON		;Kesme surec ve islemlerinin sonlandirildigi kesme alt program yigini
	    BCF	    RST		;Sayaclari sifirlama durumundan cikar.
	    BCF	    INTCON3, INT1IF	;AAR1 kesme bayragini temizle. 
	    BCF	    INTCON3, INT2IF	;AAR2 kesme bayragini temizle.
;Kesme bayraklarini temizleme isi cok onemli. Eger kesmeden cikmadan temizlenmezse hatali kesmeler
;olusabilir. O yuzden bu bayraklarin temizlendiginden emin olduktan sonra kesmeden cikacagiz.
	    BTFSC   INTCON3, INT1IF	;AAR1 kesme bayraginin temizlendiginden emin ol.
	    BRA	    AAR_SON	    ;Temizlenmemisse temizleme islemini yeniden yapmak icin AAR_SON a geri git.
	    BTFSC   INTCON3, INT2IF	;AAR2 kesme bayraginin temizlendiginden emin ol.
	    BRA	    AAR_SON	    ;Temizlenmemisse temizleme islemini yeniden yapmak icin AAR_SON a geri git.
	    MOVLW   0XE0	   ;Bayraklarin temizlendiginden emin olduktan sonra buradan devam et.
	    MOVWF   INTCON	;INTCON kesme denetim yazmacina yeniden normal degerleri yukle.
	    BTFSC   AAR_SR_SIFIRLA, AAR1_SR	;10s dolmadan 1. motorda hata oldu mu?
	    BRA	    BASLAT2_KUR			;Evetse 1. motoru yeniden kurmak icin BASLAT2_KUR alt  prg dallan.
	    BTFSC   AAR_SR_SIFIRLA, AAR2_SR	;Hayirsa, 2. motorda 30s dolmadan hata oldu mu?
	    BRA	    BASLAT2_KUR			;Hata olduysa(evetse), 1. ve 2. motoru yeniden kurmak icin BASLAT2_KUR alt  prg dallan.
	    BTFSS   SUREV_BYRK, OTUZ	    ;Hayirsa, 30 saniye bayragi = 1 mi?
	    BSF	    T0CON, TMR0ON	    ;30s bayragi = 1 Degilse, Timer0 i yeniden saymasi icin etkinlestir.
	    BTFSS   SUREV_BYRK, OTUZ	    ;30s bayragi = 1 ise Timer0 i etkinlestirmeyi atla ve bu bayragi yeniden denetle.
	    BSF	    DEI		;Bayrak 1 ise, sayma islemi bitti, o yuzden Sayac gostergesini etkinlestirmeyi atla. 
				;Bayrak 0 ise sayma islemi suruyor, bu yuzden gostergeyi etkinlestir.
	    BCF	    INH		;Sayac saat darbesini askiya almayi durdur.
	    RETFIE	 ;Kesmeden cik.
	    
AAR1_SR_SIFIRLA		;1. Motor gereken sure (10saniye) doluncaya dek calismadiysa buradaki komutlar islenir.
	    BTFSS   AAR_SR_SIFIRLA, AAR2_SR	;2. Motor erken durdu bayragi kurulmussa, bir alttaki komutu atla.
	    BSF	    AAR_SR_SIFIRLA, AAR1_SR	;1. Motor 10s calisamadan durdu, erken durma bayragini kur.
	    BTFSC   M2		    ;2. Motor calisiyor mu?
	    CALL    M2BEKLE_KUR	    ;Evetse 1. motor sureden bagimsiz yeniden calistirilabilir cunku 2. motor zaten devrede.
				    ;Bu yuzden her seyi normale donderip 2. motorun en az 30s calismasını beklemek icin M2BEKLE_KUR alt prg cagir.
	    BSF	    RST		;2. Motor calismiyorsa, sayicilari yeniden sayma icin sifirla,
	    CLRF    TMR0L	;1. Motoru yeniden 10s calistirmak icin Timer0 i sifirla.
	    MOVLW   .38		;Yeniden 10s saymak icin,
	    MOVWF   SAY10	;SAY10 dosyasina ondegerini yeniden yukle.
	    RETURN	    ;Cagirildigin yere geri don.

AAR2_SR_SIFIRLA		;2. Motor gereken sure (30saniye) doluncaya dek calismadiysa buradaki komutlar islenir.
	    BSF	    AAR_SR_SIFIRLA, AAR2_SR	;2. Motor 30s calismadan durdu, erken durma bayragini kur.	
	    CLRF    SUREV_BYRK			;10s ve 30s bayraklarini temizle (cunku sayma yeniden baslayacak)
	    BCF	    M1			;1. Motoru durdur, cunku 2. Motorun yeniden calisabilmesi icin 1. Motor yeniden 10s calismali.
	    CALL    AAR1_SR_SIFIRLA	;Simdi 1. motoru yeniden kurmak icin AAR_SR_SIFIRLA alt prg cagir.
	    MOVLW   .115	;Yeniden 30 s saymak icin,
	    MOVWF   SAY30	;SAY30 dosyasina ondegerini yeniden yukle.
	    RETURN	    ;Cagirildigin yere geri don.
	    
BASLAT2_KUR		;Motorlarin herhangi birinde basladiktan sonra ve sureleri dolmadan once hata olursa buradaki komutlar islenir.
	    BSF	    M1		;1. Motoru yeniden caistir.
	    BCF	    INH		;Sayicilarin saat darbesini engellemeyi kaldir.
	    BSF	    DEI		;Sayici gostergelerini etkinlestir.
	    BSF	    T0CON, TMR0ON	;Timer0 i yeniden etkinleştir.
	    BCF	    RST		;Sayicilari sifirlama durumundan cikar
	    BRA	    BASLAT2	;BASLAT2 etiketine dallan.
	    
M2BEKLE_KUR		;Eger 1.motor 10s calistiktan sonra hata vermis ve 2. motor calismaya baslamissa buradaki komutlar islenir.
	    BCF	    INTCON3, INT1IF	;AAR1 kesme bayragini temizle
	    BCF	    INTCON3, INT2IF	;AAR2 kesme bayragini temizle
	    BTFSC   INTCON3, INT1IF	;
	    BRA	    M2BEKLE_KUR
	    BTFSC   INTCON3, INT2IF	;
	    BRA	    M2BEKLE_KUR		;Bayraklarin temizlendiginden emin olana kadar dongude kal.
	    MOVLW   0XE0
	    MOVWF   INTCON		;INTCON kesme denetim yazmacini yeniden normal degerleriyle yukle.
	    BTFSS   SUREV_BYRK, OTUZ	;2. Motor 30s calisti mi?
	    CALL    SAYAC_KUR		;Evetse, burayı atla, hayırsa sayaci yeniden kurmak icin alt prgm cagir.
	    BRA	    M2_BEKLE	    ;M2_BEKLE etiketine dallan.
SAYAC_KUR
	    BSF	    T0CON, TMR0ON	;Timer0 i yeniden etkinlestir.
	    BSF	    DEI		    ;Gostergeleri yeniden etkinlestir.	
	    BCF	    INH		    ;Saat darbesini engellemeyi kaldir.
	    BCF	    M1HATA	    ;1. Motor hata gostergesini temizle.
	    BSF	    M1		    ;1. Motoru calistir.
	    RETURN
	    

;***********************ZAMANLAMA_KESME_SERVIS_RUTINI***************************
	    
SUREV			;Kac saniye sayilacaginin belirlendigi bolum.
	    BCF	    INTCON, TMR0IE	;Timer0 kesmesini etkisizlestir.
	    BTFSC   M2		    ;2. Motor calismiyorsa,
	    GOTO    SUREV2	    ;Bu komutu atla.
	    DECFSZ  SAY10,F	    ;10s icin yazilim sayacını 1 eksilt ve dosyaya sakla.
	    GOTO    BITTI	    ;SAY10 = 0 ise bu komutu atla. Degilse kesmeden cikmak icin BITTI etiketine git.
	    BSF	    SUREV_BYRK, ON	;SAY10 = 0 ise 10s doldu, 10s bayragini kur.
	    
SUREV2			;30s sayim isleminin yapildigi bolum.
	    DECFSZ  SAY30,F	    ;30s icin yazilim sayacını 1 eksilt ve dosyaya sakla.
	    GOTO    BITTI	    ;SAY30 = 0 ise bu komutu atla. Degilse kesmeden cikmak icin BITTI etiketine git.
	    BSF	    SUREV_BYRK, OTUZ	;SAY30 = 0 ise 30s doldu, 30s bayragini kur.
	    
BITTI			;Timer0 kesmesinden cikis yapilan bolum. 
	    BCF	    INTCON, TMR0IF	;Timer0 kesme bayragini temizle.
	    BSF	    INTCON, TMR0IE	;Timer0 kesmesini yeniden kur
	    RETFIE 		    ;Timer0 kesmesinden cik.

BITIR
	    GOTO BITIR		    ;Program sonu
	    END
	    
	    
	